#include "omp.h"
// dimensional information ( t,x,y,z, note that x,y,z info are after tapering/padding)
int XC3dWaveprop_1step2t2space(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t4space(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t6space(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t8space(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t10space(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t10spacewithbnd(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t10spacewithbnd1(float *veldtinvdx2, int izmin, int izmax);
int XC3dWaveprop_1step2t10spacewithbnd1opt(float *veldtinvdx2, int izmin, int izmax);
//int XC3dWaveprop_1step4t10spacewithbnd1opt1(float *veldtinvdx2, int izmin, int izmax, float *tmparray, float *xval, float *yval, float *zval);
int XC3dWaveprop_1step4t10spacewithbnd1opt1(float *veldtinvdx2, int izmin, int izmax);
//int XC3dWaveprop_1step4t10spacewithbnd1opt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax  );
int XC3dWaveprop_1step4t10spacewithbnd1opt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                            int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                            int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
                                            float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                            float *XC3dWaveprop_tmpwv);
int XC3dWaveprop_1step4t10spaceopt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                    int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                    int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
                                    float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                    float *XC3dWaveprop_tmpwv);
int XC3dWaveprop_1step2t10spacewithbnd1opt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                            int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                            int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
                                            float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                            float *XC3dWaveprop_tmpwv);
int XC3dWaveprop_1step4t10spaceopt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                    int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                    int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
                                    float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                    float *XC3dWaveprop_tmpwv);
int XC3dWaveprop_1step2t10spaceopt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                    int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                    int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
                                    float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                    float *XC3dWaveprop_tmpwv);
int XC3dWaveprop_1step4t10spacewithbnd1optinvvelin(float *dxinvvelinvdt2, int izmin, int izmax);
int XC3dWaveprop_1step2t10spacewithbnd2(float *veldtinvdx2, int izmin, int izmax);
/*
#include "2t4space.h"
#include "2t6space.h"
#include "2t8space.h"
#include "2t10space.h"
#include "4t8space.h"
#include "4t10space.h"
#include "4t10spacewithbnd.h"
#include "4t10spacewithbnd1.h"
#include "4t10spaceopt.h"
*/
#include "XC3dWaveprop.h"
#include "4t10spacewithbnd1opt.h"
#include "2t10spacewithbnd1opt2.h"
#include "2t10spaceopt2.h"
#include "4t10spaceopt2.h"
//#include "4t10spacewithbnd1opt1.h"
//#include "4t10spacewithbnd1opt2.h"
#include "4t10spacewithbnd1optinvvelin.h"
//#include "4t10spacewithbnd2.h"
