///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step4t10spacewithbnd1opt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax)
{
  int fat,fat2,curidx;
  int ix,iy,iz,i;
  int iz1,iz2;
  int ix1,ix2;
  int iy1,iy2;
  int ctrx,ctry,ctrz;
  fat=5;
  fat2=5;

  float temp1;
  float *wvt1,*wvt2,*wvt3, *tmpwv;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  tmpwv=XC3dWaveprop_tmpwv;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;
  int inciz=1;
  int incix=nz;
  int inciy=nz*nx;
  int nxtape,nytape,nztape;
  nxtape=XC3dWaveprop_nxtape;
  nytape=XC3dWaveprop_nytape;
  nztape=XC3dWaveprop_nztape;

  iz1=max(0+fat,izmin-fat);
  iz2=min(nz-fat,izmax+fat);
  ix1=max(0+fat,ixmin-fat);
  ix2=min(nx-fat,ixmax+fat);
  iy1=max(0+fat,iymin-fat);
  iy2=min(ny-fat,iymax+fat);

  float a[11];

  a[0]=1./3150.;
  a[1]=-5./1008.;
  a[2]=5./126.;
  a[3]=-5./21.;
  a[4]=5./3.;
  a[5]=(a[1]+a[2]+a[3]+a[4]+a[5])*(-2.);
  a[6]=5./3.;
  a[7]=-5./21.;
  a[8]=5./126.;
  a[9]=-5./1008.;
  a[10]=1./3150.;

  float a1=5./3.;
  float a2=-5./21.;
  float a3=5./126.;
  float a4=-5./1008.;
  float a5=1./3150.;
  float a0=a1+a2+a3+a4+a5;
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;
     //#pragma omp parallel for private(iybegpad,iyendpad,whtybegpad,whtyendpad,izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)

     //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,iy) schedule(dynamic,8)
  //for (i=0;i<nx*ny*nz;i++)
  //   wvt3[i]=0; 
 
  for (iy=iy1;iy<iy2;iy++)
  {
     
     #pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,i,ctrx,ctry,ctrz) schedule(dynamic,8)
     for (ix=ix1;ix<ix2;ix++)
     {  
        /*
        //#pragma omp parallel for private(curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
           curidx=Wpzxyloc(iz,ix,iy);
           wvt3[curidx]=0;
           for (i=0;i<11;i++)
           {
              wvt3[curidx]+=a[i]*wvt2[curidx-(5-i)*inciz];
           }
           for (i=0;i<11;i++)
           {
              wvt3[curidx]+=a[i]*wvt2[curidx-(5-i)*incix];
           }
           for (i=0;i<11;i++)
           {
              wvt3[curidx]+=a[i]*wvt2[curidx-(5-i)*incix];
           }
           wvt3[curidx]*=veldtinvdx2[curidx];
        }
        */

        /*
        for (i=0;i<6;i++) 
        {
           /*
           for (iz=iz1;iz<iz2;iz++)
           {
              //pnt0
             curidx=Wpzxyloc(iz,ix,iy);
             temp1 = a[i]*wvt2[ curidx-i*inciz ] ;
             temp1+= a[i]*wvt2[ curidx+i*inciz ] ;
             temp1+= a[i]*wvt2[ curidx-i*incix ] ;
             temp1+= a[i]*wvt2[ curidx+i*incix ] ;
             temp1+= a[i]*wvt2[ curidx-i*inciy ] ;
             temp1+= a[i]*wvt2[ curidx+i*inciy ] ;
             /*
             temp1+= a[i]*wvt2[ Wpzxyloc(iz+ctrz-i,ix+ctrx,iy+ctry) ] ;
             temp1+= a[i]*wvt2[ Wpzxyloc(iz+ctrz+i,ix+ctrx,iy+ctry) ] ;
             temp1+= a[i]*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-i,iy+ctry) ] ;
             temp1+= a[i]*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+i,iy+ctry) ] ;
             temp1+= a[i]*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-i) ] ;
             temp1+= a[i]*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+i) ] ;
             wvt3[i]+=temp1; 
           }
           
        }*/
        
        for (iz=iz1;iz<iz2;iz++)
        {
          //pnt0
           ctrz=0;ctrx=0;ctry=0;
           curidx=Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry);
           curval=wvt2[curidx];
           temp1 = a5*(wvt2[ Wpzxyloc(iz+ctrz-5,ix+ctrx,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz+5,ix+ctrx,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-5,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+5,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-5) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+5) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz+ctrz-4,ix+ctrx,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz+4,ix+ctrx,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-4,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+4,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-4) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+4) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz+ctrz-3,ix+ctrx,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz+3,ix+ctrx,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-3,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+3,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-3) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+3) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz+ctrz-2,ix+ctrx,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz+2,ix+ctrx,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-2,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+2,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-2) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+2) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz+ctrz-1,ix+ctrx,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz+1,ix+ctrx,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-1,iy+ctry) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+1,iy+ctry) ] + \
                       wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-1) ] + wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+1) ] ) ;
           temp1+= -6.0*a0*curval;
           /* 
           temp1 = a5*wvt2[ Wpzxyloc(iz+ctrz-5,ix+ctrx,iy+ctry) ] ;
           temp1+= a5*wvt2[ Wpzxyloc(iz+ctrz+5,ix+ctrx,iy+ctry) ] ;
           temp1+= a4*wvt2[ Wpzxyloc(iz+ctrz-4,ix+ctrx,iy+ctry) ] ;
           temp1+= a4*wvt2[ Wpzxyloc(iz+ctrz+4,ix+ctrx,iy+ctry) ] ;
           temp1+= a3*wvt2[ Wpzxyloc(iz+ctrz-3,ix+ctrx,iy+ctry) ] ;
           temp1+= a3*wvt2[ Wpzxyloc(iz+ctrz+3,ix+ctrx,iy+ctry) ] ;
           temp1+= a2*wvt2[ Wpzxyloc(iz+ctrz-2,ix+ctrx,iy+ctry) ] ;
           temp1+= a2*wvt2[ Wpzxyloc(iz+ctrz+2,ix+ctrx,iy+ctry) ] ;
           temp1+= a1*wvt2[ Wpzxyloc(iz+ctrz-1,ix+ctrx,iy+ctry) ] ;
           temp1+= a1*wvt2[ Wpzxyloc(iz+ctrz+1,ix+ctrx,iy+ctry) ] ;
           temp1+= -6.0*a0*curval;
           temp1+= a5*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-5,iy+ctry) ] ;
           temp1+= a5*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+5,iy+ctry) ] ;
           temp1+= a4*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-4,iy+ctry) ] ;
           temp1+= a4*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+4,iy+ctry) ] ;
           temp1+= a3*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-3,iy+ctry) ] ;
           temp1+= a3*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+3,iy+ctry) ] ;
           temp1+= a2*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-2,iy+ctry) ] ;
           temp1+= a2*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+2,iy+ctry) ] ;
           temp1+= a1*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx-1,iy+ctry) ] ;
           temp1+= a1*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx+1,iy+ctry) ] ;
           temp1+= a5*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-5) ] ;
           temp1+= a5*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+5) ] ;
           temp1+= a4*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-4) ] ;
           temp1+= a4*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+4) ] ;
           temp1+= a3*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-3) ] ;
           temp1+= a3*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+3) ] ;
           temp1+= a2*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-2) ] ;
           temp1+= a2*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+2) ] ;
           temp1+= a1*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-1) ] ;
           temp1+= a1*wvt2[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+1) ] ;*/
           wvt3[curidx]=temp1*veldtinvdx2[curidx];
        } 
     }
  }
  
  
  a2=-1./12.;
  a1=4./3.;
  a0=(a1+a2);
  
  for (iy=iy1;iy<iy2;iy++)
  {
     #pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,i,ctrx,ctry,ctrz) schedule(dynamic,8)
     for (ix=ix1;ix<ix2;ix++)
     {
        for (iz=iz1;iz<iz2;iz++)
        {
           curidx=Wpzxyloc(iz,ix,iy);
           curval=wvt3[ curidx ];
           /*
           temp1=0;
           for (i=0;i<5;i++)
           {
              temp1+=a[i]*wvt3[curidx-(2-i)*inciz];
              temp1+=a[i]*wvt3[curidx-(2-i)*incix];
              temp1+=a[i]*wvt3[curidx-(2-i)*inciy];
           } 
          */
          temp1 = a2*(wvt3[ Wpzxyloc(iz+ctrz-2,ix+ctrx,iy+ctry) ] + wvt3[ Wpzxyloc(iz+ctrz+2,ix+ctrx,iy+ctry) ] );
          temp1+= a2*(wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx-2,iy+ctry) ] + wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx+2,iy+ctry) ] );
          temp1+= a2*(wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-2) ] + wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+2) ] );
          temp1+= a1*(wvt3[ Wpzxyloc(iz+ctrz-1,ix+ctrx,iy+ctry) ] + wvt3[ Wpzxyloc(iz+ctrz+1,ix+ctrx,iy+ctry) ] );
          temp1+= a1*(wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx-1,iy+ctry) ] + wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx+1,iy+ctry) ] );
          temp1+= a1*(wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry-1) ] + wvt3[ Wpzxyloc(iz+ctrz,ix+ctrx,iy+ctry+1) ] );
          temp1+= -6.0*a0*curval;
          temp1*=a2*veldtinvdx2[curidx];
          temp1=curval-temp1;
          wvt1[curidx] = 2.0*wvt2[curidx]- wvt1[curidx] + temp1;
        }
     }
  }
  
  ////////////////////////////////////////////////////
  //boundary condition
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iy,iz) schedule(dynamic,8)
  for (iy=nytape;iy<ny-nytape;iy++)
  {
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=nxtape;ix<nx-nxtape;ix++)
     {
        //beg z boundary
        
        for (iz=nztape-1;iz>=0+fat+fat2;iz--)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz-1,ix,iy)]-curval));
          outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[curidx-1]-curval));
          wvt1[curidx] = outval;
        }
        for (iz=0+fat+fat2;iz>=0+fat;iz--)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz+1,ix,iy)]))+wvt2[Wpzxyloc(iz+1,ix,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+1]))+wvt2[curidx+1];
          wvt1[curidx] = outval;
        }
        //end z boundary
        for (iz=nz-nztape;iz<nz-fat-fat2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz+1,ix,iy)]-curval));
          outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[curidx+1]-curval));
          wvt1[curidx] = outval;
        }
        for (iz=nz-fat-fat2;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz-1,ix,iy)]))+wvt2[Wpzxyloc(iz-1,ix,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-1]))+wvt2[curidx-1];
          wvt1[curidx] = outval;
        }
     }

     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     //beg x boundary
     for (ix=nxtape-1;ix>0+fat+fat2;ix--)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix-1,iy)]-curval));
          outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[curidx-nz]-curval));
          wvt1[curidx] = outval;
        }
     }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat+fat2;ix>=0+fat;ix--)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix+1,iy)]))+wvt2[Wpzxyloc(iz,ix+1,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+nz]))+wvt2[curidx+nz];
          wvt1[curidx] = outval;
        }
     }

     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     //end x boundary
     for (ix=nx-nxtape;ix<nx-fat-fat2;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix+1,iy)]-curval));
          outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[curidx+nz]-curval));
          wvt1[curidx] = outval;
        }
     }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=nx-fat-fat2;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix-1,iy)]))+wvt2[Wpzxyloc(iz,ix-1,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-nz]))+wvt2[curidx-nz];
          wvt1[curidx] = outval;
        }
     }
  }

  ////////////////////////////////////////////////////
  //beg y boundary
  for (iy=nytape-1;iy>0+fat+fat2;iy--)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nytape-iy))/nytape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix,iy-1)]-curval));
          outval -= (tpwht*(nytape-iy))/nytape*(scurv*(outval-curval)+curv*(wvt2[curidx-nz*nx]-curval));
          wvt1[curidx] = outval;
        }
     }
  }
  
  for (iy=0+fat+fat2;iy>=0+fat;iy--)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix,iy+1)]))+wvt2[Wpzxyloc(iz,ix,iy+1)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+nz*nx]))+wvt2[curidx+nz*nx];
          wvt1[curidx] = outval;
        }
     }
  }
  //end y boundary
  for (iy=ny-nytape;iy<ny-fat-fat2;iy++)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+iy+nytape-ny)/nytape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix,iy+1)]-curval));
          outval -= tpwht*(0.+iy+nytape-ny)/nytape*(scurv*(outval-curval)+curv*(wvt2[curidx+nz*nx]-curval));
          wvt1[curidx] = outval;
        }
     }
  }
  
  for (iy=ny-fat-fat2;iy<ny-fat;iy++)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix,iy-1)]))+wvt2[Wpzxyloc(iz,ix,iy-1)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-nz*nx]))+wvt2[curidx-nz*nx];
          wvt1[curidx] = outval;
        }
     }
  }
   
  return 0; 
}
