// dimensional information ( t,x,y,z,s, note that x,y,z info are after tapering/padding)
int   XC3dAcouMod_nt,XC3dAcouMod_nx,XC3dAcouMod_ny,XC3dAcouMod_nz,XC3dAcouMod_ns;
float XC3dAcouMod_ot,XC3dAcouMod_ox,XC3dAcouMod_oy,XC3dAcouMod_oz;
float XC3dAcouMod_dt,XC3dAcouMod_dx,XC3dAcouMod_dy,XC3dAcouMod_dz;
float *XC3dAcouMod_sdep, *XC3dAcouMod_rdep;
int *XC3dAcouMod_isdep, *XC3dAcouMod_irdep;
//tapering/padding information ( in x,y,z directions) 
int   XC3dAcouMod_nxtape,XC3dAcouMod_nytape,XC3dAcouMod_nztape;
int   XC3dAcouMod_nxt,XC3dAcouMod_nyt,XC3dAcouMod_nzt;
float *XC3dAcouMod_vel;
float *XC3dAcouMod_veldtinvdx2;
float XC3dAcouMod_vmax;
//incremental z range of wavefield to be calculated as t increases
int   XC3dAcouMod_izmax_inc;

#define zxyloc(iz,ix,iy) ((iz)+(ix)*XC3dAcouMod_nz+(iy)*XC3dAcouMod_nz*XC3dAcouMod_nx)
#define xyloc(ix,iy)  ((ix)+(iy)*XC3dAcouMod_nx)
#define Errmsg(str)  {fprintf(stderr,str);return 1;}
#define Errmsg2(str,str1)  {fprintf(stderr,str,str1);return 1;}
#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}

int XC3dAcouMod_Init( int ntin,  int nxin,  int nyin,  int nzin, int nsin,  \
                      float otin,float oxin,float oyin,float ozin,          \
                      float dtin,float dxin,float dyin,float dzin,          \
                      int nxtapein, int nytapein, int nztapein,             \
                      float* sdepin, float *rdepin, float* velin,           \
                      int needwvmvin, int jtmvin, int freesurf );
int XC3dAcouMod_op(int tsign, int is, float *src, float *dat, float *wvmv);
int XC3dAcouMod_op_rndbnd(int tsign, int is, float *src, float *dat, float *wvmv);
int XC3dAcouMod_op_rndbnd1(int tsign, int is, float *src, float *dat, float *wvmv);
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
