#include SEP rules

# define related directories
RESDIR = Fig
mydir=/net/server/wrk/sep143/xukai2
BINDIR = ${mydir}/Bin
OBJDIR = ${mydir}/Obj
SRCDIR = ${mydir}/Src
RESULTSER =
RESULTSCR =
RESULTSNR = 
#FFTWLIBS = -L/opt/FFTW/lib/ -lfftw3f
#UF90LIBS = -lsepgeef90 -lsep2df90 -lsep3df90 -lsep3d -lsepf90 -lsep -lsupersetf90 -lsuperset -lsep -lsepauxf90 ${FFTWLIBS}
#UF90INCLUDES = -I.
#UF90FLAGS = -CB



######################################################################################################################
CC = gcc
UCINCLUDES = -I/opt/FFTW/include -I./

#CMNLIBPATH = -L/opt/MPI/lib  
#CMNINCPATH = -I/opt/MPI/include 

CULIBS    = -lcutil -lcudart -lcublas -lcufft -lcuda
#CULIBS    = -lcutil -lcublas -lcufft -lcuda
CUINCPATH = $(CMNINCPATH) -I/opt/nvidia/cuda-2.3_sdk/C/common/inc/ -I/usr/local/cuda/include/
CULIBPATH = $(CMNLIBPATH) -L/opt/nvidia/cuda-2.3_sdk/C/common/lib/linux -L/opt/nvidia/cuda-2.3_sdk/C/lib
#CULIBPATH = $(CMNLIBPATH) -L/usr/local/cuda/lib64 -L/opt/nvidia/cuda-2.3_sdk/C/common/lib/linux -L/opt/nvidia/cuda-2.3_sdk/C/lib

XCuda%.o : ${SRCDIR}/XCuda%.cu
	nvcc -c $< $(CUINCPATH) $(CULIBPATH) $(CULIBS) -arch=sm_13 --ptxas-options=-v
######################################################################################################################
MPIDIR=/opt/MPI/mpich2-1.2.1-install


F90C = ${MPIDIR}/bin/mpif90 -f90=ifort -openmp -I. -static-intel -check bounds 
F90LD = ${MPIDIR}/bin/mpif90 -f90=ifort -openmp  -static-intel #${LDFLAGS} -L${SEPLIBDIR} 

MYFC = /opt/MPI/bin/mpif90 -f90=ifort -static-intel
a2us = -assume 2underscores

#farg.o : ${MPISRCDIR}/src/fortran/src/farg.f
#	${MYFC} -c $< ${a2us}

######################################################################################################################
FCOLEVEL = 3
MAIN_LIBS=-lsep2df90
SEPstuff= -I ${SEP}/include/  -L ${SEP}/lib
FFTWLIBS = -L/opt/FFTW/lib/ -lfftw3f -L${mydir}/lib/ -lfftw3

UF90INCLUDES=-I. -I${MPIDIR}/include/${CUINCPATH}
UF90LIBS= -lsepauxf90 -lsepmathf90  -L${MPIDIR}/lib ${MAIN_LIBS} ${SEPstuff} ${FFTWLIBS} ${CULIBPATH} ${CULIBS}

######################################################################################################################
#INCDIR=${SEP}/include/
#SEPLIBDIR=${SEP}/lib/
#SEPLIBS=-lsuperset -lsep3d -lsepf90 -lsep -lm
#MYLIBDIR=${MYDEV}/lib
#MYLIBS= -lsgjmig -lsgjbase
#MYINC=${MYDEV}/src/include/
#FLAGS=-O3
#GCC=/opt/intel/cce/9.1.042/bin/icc
#ALLFLAG= ${FLAGS} -I ${INCDIR} -I ${MYINC} -I /opt/intel_fce_80/include/ -L ${MYLIBDIR}  ${MYLIBS}  -L ${SEPLIBDIR} ${SEPLIBS}  -L/opt/intel_fce_80/lib/
#%.x:%.c ${MYLIBDIR}/libsgjmig.a  ${MYLIBDIR}/libsgjbase.a
#        ${GCC} $*.c -o $@ ${ALLFLAG}
######################################################################################################################
FCEFLAGS= -I /opt/Intel/fce/10.0.023/include/ -L /opt/Intel/fce/10.0.023/lib/
CCEFLAGS= -I/opt/intel/Compiler/11.1/059/include/ -L/opt/intel/Compiler/11.1/059/lib/ 

SEPINCDIR = ${SEP}/include/
SEPLIBDIR = ${SEP}/lib/
SEPLIBS = -lsuperset -lsep3d -lseppar -lsep  
MYINC = -I${mydir}/Src/ -I${mydir}/Src/3dstencil/ -I/opt/FFTW/include 
MYLIB =  -L /opt/FFTW/lib -lfftw3f  -L ./lib -lfftw3
FLAGS = -O2 -openmp
CC=/opt/intel/Compiler/11.1/059/bin/intel64/icc
CLD=/opt/intel/Compiler/11.1/059/bin/intel64/icc -L${SEPLIBDIR} ${SEPLIBS}
ALLFLAG= ${FLAGS} -I ${SEPINCDIR} -L ${SEPLIBDIR} ${SEPLIBS} ${MYINC} ${FCEFLAGS} ${CCEFLAGS}
ALLCCFLAG= ${FLAGS} -I ${SEPINCDIR} -L ${SEPLIBDIR} ${SEPLIBS} ${CCEFLAGS} ${MYINC} ${MYLIB}
OCFLAGS= -I${SEPINCDIR} -L${SEPLIBDIR} ${SEPLIBS} -O2 -openmp ${CCEFLAGS} ${MYINC} ${MYLIB}
OCOPTIMFLAGS= -O2 -openmp
${OBJDIR}/%.o:${SRCDIR}/%.c 
	${CC} ${SRCDIR}/$*.c -c -o $@ ${ALLCCFLAG}

#${OBJDIR}/4t10spacewithbnd1opt2.o ${OBJDIR}/4t10spaceopt2.o
${BINDIR}/XC3dAcouModMain.x:${OBJDIR}/XC3dAcouModMain.o  ${OBJDIR}/XC3dWaveprop.o ${OBJDIR}/XC3dAcouMod.o  ${OBJDIR}/4t10spacewithbnd1opt2.o
	${CC} ${OBJDIR}/XC3dAcouModMain.o ${OBJDIR}/XC3dWaveprop.o ${OBJDIR}/XC3dAcouMod.o ${OBJDIR}/4t10spacewithbnd1opt2.o -o $@ ${ALLCCFLAG}

${BINDIR}/XC3dRndbndVel.x:${SRCDIR}/XC3dRndbndVel.c
	${CC} ${SRCDIR}/XC3dRndbndVel.c -o $@ ${ALLCCFLAG}

${BINDIR}/XC3dRndbndVelGrain.x:${SRCDIR}/XC3dRndbndVelGrain.c
	${CC} ${SRCDIR}/XC3dRndbndVelGrain.c -o $@ ${ALLCCFLAG}

${BINDIR}/XC3dRndbndVelGrainNew.x:${SRCDIR}/XC3dRndbndVelGrainNew.c
	${CC} ${SRCDIR}/XC3dRndbndVelGrainNew.c -o $@ ${ALLCCFLAG}

${BINDIR}/XC3dRndbndVelGrainNew1.x:${SRCDIR}/XC3dRndbndVelGrainNew1.c
	${CC} ${SRCDIR}/XC3dRndbndVelGrainNew1.c -o $@ ${ALLCCFLAG}

${BINDIR}/XC3dMakesrc.x:${SRCDIR}/XC3dMakesrc.c
	${CC} ${SRCDIR}/XC3dMakesrc.c -o $@ ${ALLCCFLAG}

${BINDIR}/XFt.x:${SRCDIR}/XFt.c
	${CC} ${SRCDIR}/XFt.c -o $@ ${ALLCCFLAG}





